package digital.laboratory.platform.sys;

import cn.hutool.core.codec.Base64;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import digital.laboratory.platform.common.core.exception.CheckedException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.*;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.client.HttpClientErrorException;
import org.springframework.web.client.RestTemplate;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.Map;


@Controller
public class LoginController {
    @Autowired
    RestTemplate restTemplate;

    String authServerURL = "";
	String clientId = "";
	String clientSecret = "";

	@Value("${authServerURL}")
	public void setAuthServerURL(String authServerURL) {
		this.authServerURL = authServerURL;
	}

	@Value("${clientId}")
	public void setClientId(String clientId) {
		this.clientId = clientId;
	}
	@Value("${clientSecret}")
	public void setClientSecret(String clientSecret) {
		this.clientSecret = clientSecret;
	}

	// 之前已经向 authServer 提交用户名和密码并通过, authServer将重定向到这个地址, 并把 code 作为参数
	// 我们应该向 authServer 获取 token, 并保存 token 到 cookie 中, 然后重定向到 /
	@GetMapping("/login-callback")
	public void login_callback(String code, String access_token, HttpServletRequest request, HttpServletResponse response) throws IOException {


System.out.println(String.format("login_callback start... >>>>>"));

		System.out.println(String.format("access_token = %s", access_token));
		System.out.println(String.format("request.getQueryString() = %s", request.getQueryString()));
		System.out.println(String.format("request.getRequestURI() = %s", request.getRequestURI()));
		System.out.println(String.format("request.getServletPath() = %s", request.getServletPath()));
		System.out.println(String.format("request.getPathTranslated() = %s", request.getPathTranslated()));
		System.out.println(String.format("request.getContextPath() = %s", request.getContextPath()));
		System.out.println(String.format("request.getRequestURL() = %s", request.getRequestURL().toString()));
		System.out.println(String.format("request.getPathTranslated() = %s", request.getPathTranslated()));
		//System.out.println(String.format("request.getContextPath() = %s", request.getHeaders().toString()));
		System.out.println(String.format("request.getPathInfo() = %s", request.getPathInfo()));
		System.out.println(String.format("request.getTrailerFields() = %s", request.getTrailerFields().toString()));



		if (code != null) {
			// 请求的 URI 中带有 code
			MultiValueMap<String, String> map = new LinkedMultiValueMap<>();
			map.add("code", code);
			map.add("client_id", "UserManagement");
			map.add("client_secret", "um87990016");
			map.add("redirect_uri", "http://localhost:8080/login-callback");
			map.add("grant_type", "authorization_code");
			System.out.println(String.format("code=%s", code));
			System.out.println(String.format("map=%s", map.toString()));
			Map<String,String> resp = restTemplate.postForObject("http://dlp-auth-server:5201/oauth/token", map, Map.class);
			String my_access_token = resp.get("access_token");
			System.out.println("access_token=["+my_access_token+"]");
			map.add("access_token", my_access_token);

			//String token_expires_in = resp.get("expires_in");

			response.addCookie(new Cookie("token_type", resp.get("token_type")));
			response.addCookie(new Cookie("access_token", resp.get("access_token")));
			response.addCookie(new Cookie("refresh_token", resp.get("refresh_token")));
			//response.addCookie(new Cookie("token_expires_in", token_expires_in));

			for (String key : resp.keySet()) {
				System.out.println(String.format("RESP key = [%s] value = [%s]", key, resp.get(key)));
			}

//			try {
//				HttpHeaders headers = new HttpHeaders();
//				headers.add("Authorization", "Bearer " + access_token);
//				HttpEntity<Object> httpEntity = new HttpEntity<>(headers);
//				ResponseEntity<String> entity = restTemplate.exchange("http://192.168.2.99:4000/user/info", HttpMethod.GET, httpEntity, String.class);
//
//				mv.addObject("msg", entity.getBody());
//			}
//			catch(Exception e) {
//				mv.addObject("msg", "调用资源服务器异常 ");
//			}


			//return R.ok(userService.getUserInfo(user));
		}
		else if (access_token != null) {
			// 请求的 URI 中带有 access_token。如果 授权类型为 Implicit, 则重定向的 URI 中带有 access_token, 而不是 code
//			response.addCookie(new Cookie("token_type", resp.get("token_type")));
//			response.addCookie(new Cookie("access_token", access_token));
//			response.addCookie(new Cookie("refresh_token", resp.get("refresh_token")));

		}

		try {
			System.out.println(String.format("request.getPathInfo()=%s", request.getPathInfo()));
			System.out.println(String.format("request.getAuthType()=%s", request.getAuthType()));
			System.out.println(String.format("request.getContextPath()=%s", request.getContextPath()));
			System.out.println(String.format("request.getCookies()=%s", request.getCookies().toString()));
			System.out.println(String.format("request.getPathTranslated()=%s", request.getPathTranslated()));
			System.out.println(String.format("request.getPathInfo()=%s", request.getPathInfo()));
			System.out.println(String.format("request.getRequestURI()=%s", request.getRequestURI()));
			System.out.println(String.format("request.getRemoteUser()=%s", request.getRemoteUser()));
			System.out.println(String.format("request.getRequestedSessionId()=%s", request.getRequestedSessionId()));
			System.out.println(String.format("request.getRequestURL()=%s", request.getRequestURL().toString()));
//		System.out.println(String.format("request.getUserPrincipal()=%s", request.getUserPrincipal().toString()));
			System.out.println(String.format("request.getServletPath()=%s", request.getServletPath()));
			System.out.println(String.format("request.getSession()=%s", request.getSession().toString()));
		}
		catch(Exception e) {
			//System.out.println(String.format("show request info excepted, e:%s", e.getStackTrace()));
			e.printStackTrace();
		}

//		response.sendRedirect("/");
		response.sendRedirect("http://localhost:8080/");

System.out.println(String.format("login_callback exit"));

		//mv.setViewName("redirect:/");
	}

    @GetMapping("/hello")
    public String hello(String code, Model model) {
        if (code != null) {
            MultiValueMap<String, String> map = new LinkedMultiValueMap<>();
            map.add("code", code);
            map.add("client_id", "UserManagement");
            map.add("client_secret", "um87990016");
            map.add("redirect_uri", "http://192.168.1.99:4000/hello");
            map.add("grant_type", "authorization_code");
System.out.println(String.format("code=%s", code));
System.out.println(String.format("map=%s", map.toString()));
            Map<String,String> resp = restTemplate.postForObject(authServerURL, map, Map.class);
            String access_token = resp.get("access_token");
System.out.println("access_token=["+access_token+"]");
			map.add("access_token", access_token);
/*
			try {
	            HttpHeaders headers = new HttpHeaders();
	            headers.add("Authorization", "Bearer " + access_token);
	            HttpEntity<Object> httpEntity = new HttpEntity<>(headers);
	            ResponseEntity<String> entity = restTemplate.exchange("http://192.168.2.99:4000/user/info", HttpMethod.GET, httpEntity, String.class);
	            model.addAttribute("msg", entity.getBody());
			}
			catch(Exception e) {
				model.addAttribute("msg", "调用资源服务器异常 ");
			}
*/
			model.addAllAttributes(map);

        }
        return "index";
    }

    @GetMapping("/list")
    @ResponseBody
    public String list() {
        return "index /list, authServerURL="+authServerURL;
    }


//	@Resource
//	private HttpServletResponse response;
	        //HttpServletResponse response;
	/**
	 * 这是 OAuth2 的 password 授权类型. 浏览器向资源拥有者(本程序, client)提交用户名和密码,
	 * client 向 AuthServer 提交 用户名和密码, 以及 client_id&client_secret后, AuthServer 直接颁发 access_token
	 * 参考 https://datatracker.ietf.org/doc/html/rfc6749#section-4.3
	 *
	 * @param username
	 * @param password
	 * @param request
	 *
	 * @return
	 */
	@PostMapping("/login")
	//@ResponseBody
	public void login(@RequestParam("username") String username, @RequestParam("password") String password, HttpServletRequest request, HttpServletResponse response) throws IOException {
//		System.out.println(String.format("post login start... >>>>>"));
//		System.out.println(String.format("username=%s, password=%s", username, password));
//		System.out.println(String.format("authServerURL=%s", authServerURL));

		//---- 记录客户端的 id ---------------------------
		boolean clientIdExists = false;

		Cookie[] cookies = request.getCookies();
		if (cookies!= null) {
//			System.out.println(String.format("Cookie 数量: %d", cookies.length));
			for (int i = 0; i < cookies.length; i++) {
//				System.out.println(String.format("Cookie %d: Name=%s, toString:=%s", i, cookies[i].getName(), cookies[i].toString()));
				if (StrUtil.equalsIgnoreCase("client-id", cookies[i].getName())) {
//					System.out.println(String.format("---> get client-id=%s", cookies[i].toString()));
					clientIdExists = true;
				}
			}
		}
		else {
//			System.out.println(String.format("客户端没有任何 Cookie"));
		}
			if (!clientIdExists) {
				// clientId 不存在, 生成一个, 我们要用这个 clientId 来跟踪用户的电脑
				Cookie cookie = new Cookie("client-id", IdWorker.get32UUID().toUpperCase());
				response.addCookie(cookie);
//				System.out.println(String.format("---> set client-id=%s", cookie.toString()));
			}

		//---- 以上 记录客户端的 id ---------------------------

		//HttpServletResponse resp = new HttpServletResponse();
		//请求头
		HttpHeaders headers = new HttpHeaders();

		String clientCredential = clientId+":"+clientSecret;
		byte[] clientCredentialBytes = clientCredential.getBytes(StandardCharsets.UTF_8);
		byte[] encoded;
		try {
			encoded = Base64.encode(clientCredentialBytes, false);
		}
		catch (IllegalArgumentException e) {
			throw new CheckedException("Failed to encode basic authentication token");
		}
		String clientCredentialBase64 = new String(encoded, StandardCharsets.UTF_8);
		headers.add("Authorization", "Basic "+clientCredentialBase64);

		headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
		MultiValueMap<String, String> map = new LinkedMultiValueMap<>();
		map.add("grant_type", "password");
		map.add("username", username);
		map.add("password", password);
		HttpEntity<MultiValueMap> entity = new HttpEntity<MultiValueMap>(map, headers);

		String resp;
		try {
			resp = restTemplate.postForObject(authServerURL, entity, String.class);
//			System.out.println(String.format("调用鉴权, 返回=%s", resp));
			response.setStatus(200);
			response.getWriter().print(resp);
		}
		catch (HttpClientErrorException ex) {
//			System.out.println(String.format("调用鉴权发生异常 ex=%s", ex.toString()));
//			System.out.println(String.format("111 ex.getRawStatusCode()=%d, ex.getStatusText()=%s", ex.getRawStatusCode(), ex.getStatusText()));
//			System.out.println(String.format("ex.getResponseBodyAsString()=%s", ex.getResponseBodyAsString()));
//			System.out.println(String.format("ex.getResponseHeaders()=%s", ex.getResponseHeaders().toString()));
//			System.out.println(String.format("ex... ContentType().getType()=%s", ex.getResponseHeaders().getContentType().getType()));
//			System.out.println(String.format("ex... ContentType().toS()=%s", ex.getResponseHeaders().getContentType().toString()));

//			ex.printStackTrace();
			response.reset();
			response.setStatus(ex.getRawStatusCode());
			response.setContentType("application/json; charset=utf-8");
			response.getWriter().print(ex.getResponseBodyAsString());

		}

		//Map<String,String> resp = restTemplate.postForObject(authServerURL+"?grant_type=password&username="+username+"&password="+password, map, Map.class);

//		Cookie token_type = new Cookie("token_type", resp.get("token_type"));
//		Cookie access_token = new Cookie("access_token", resp.get("access_token"));
//		Cookie refresh_token = new Cookie("refresh_token", resp.get("refresh_token"));
//
//			response.addCookie(new Cookie("token_type", resp.get("token_type")));
//			response.addCookie(new Cookie("access_token", resp.get("access_token")));
//			response.addCookie(new Cookie("refresh_token", resp.get("refresh_token")));
			//response.addCookie(new Cookie("token_expires_in", token_expires_in));

	}

}
