package digital.laboratory.platform.sys.controller;

import digital.laboratory.platform.sys.service.AppService;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import digital.laboratory.platform.sys.entity.SysUser;
import digital.laboratory.platform.sys.service.SysUserService;
import digital.laboratory.platform.common.core.util.R;
import digital.laboratory.platform.common.security.annotation.Inner;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author lengleng
 * @date 2021/9/16 移动端登录
 */
@RestController
@AllArgsConstructor
@RequestMapping("/app")
@Api(tags = "手机管理", description="未使用", hidden=true)
public class AppController {

	private final AppService appService;

	private final SysUserService userService;

	@Inner(value = false)
	@GetMapping("/{mobile}")
	public R sendSmsCode(@PathVariable String mobile) {
		return appService.sendSmsCode(mobile);
	}

	/**
	 * 获取指定用户全部信息
	 * @param mobile 手机号
	 * @return 用户信息
	 */
	@Inner
	@GetMapping("/info/{mobile}")
	public R infoByMobile(@PathVariable String mobile) {
		SysUser user = userService.getOne(Wrappers.<SysUser>query().lambda().eq(SysUser::getPoliceNo, mobile));
		if (user == null) {
			return R.failed(String.format("用户信息为空 %s", mobile));
		}
		return R.ok(userService.getUserInfo(user));
	}
}
