package digital.laboratory.platform.sys.mapper;

import digital.laboratory.platform.sys.entity.SysUserRole;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import digital.laboratory.platform.sys.entity.SysRole;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Set;

@Mapper
public interface SysRoleMapper extends BaseMapper<SysRole> {

	/**
	 * 通过用户ID, 查询岗位信息
	 * @param userId
	 * @return
	 */
	List<SysRole> listRolesByUserId(String userId);

	/**
	 * 通过权限查询岗位
	 * @param permission 岗位ID
	 * @return
	 */
	Set<SysUserRole> listUserRolesByPermission(@Param("userId")String userId, @Param("permission")String permission);
}
