package digital.laboratory.platform.sys.mapper;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import digital.laboratory.platform.sys.entity.SysUser;
import digital.laboratory.platform.sys.vo.Staff;
import digital.laboratory.platform.sys.vo.UserVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * 用户表 Mapper 接口
 * </p>
 *
 */
@Mapper
public interface SysUserMapper extends BaseMapper<SysUser> {

//	SysUser getUserByUsername(String username); // xxx

	/**
	 * 通过用户名查询用户信息(含有岗位信息)
	 *
	 * @param username 用户名
	 *
	 * @return userVo
	 */
	UserVO getUserVoByUsername(String username);

	/**
	 * 分页查询用户信息(含岗位)
	 *
	 * @param page    分页
	 * @param qw 查询参数
	 *
	 * @return list
	 */
	IPage<List<UserVO>> getUserVosPage(Page page, @Param(Constants.WRAPPER) QueryWrapper<UserVO> qw);

	/**
	 * 通过ID查询用户信息
	 *
	 * @param id 用户ID
	 *
	 * @return userVo
	 */
	UserVO getUserVoById(String id);


	//List<UserVO> selectVoList(@Param("query") UserDTO userDTO);

	List<SysUser> listAllUsersByPermission(@Param("permissions") List<String> permissions);

	List<Staff> getStaffList(@Param(Constants.WRAPPER) QueryWrapper<Staff> qw);
}
