package digital.laboratory.platform.sys.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.IService;
import digital.laboratory.platform.sys.entity.Area;
import digital.laboratory.platform.sys.vo.AreaVO;

import java.util.List;

/**
 * <p>
 * 省/地/县 3级行政区划 服务类
 * </p>
 *
 * @author Zhang Xiaolong
 * @since 2022-03-10 09:45:58
 * @describe 省/地/县 3级行政区划服务类
 */
public interface AreaService extends IService<Area> {
	/**
	 * 获取所有的省份列表
	 * @return
	 */
	List<Area> getProvinces();
	List<AreaVO> listAreaVO(QueryWrapper<Area> qw);
}
