
package digital.laboratory.platform.sys.service;

import cn.hutool.core.lang.tree.Tree;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.IService;
import digital.laboratory.platform.sys.entity.Dictionary;
import digital.laboratory.platform.sys.vo.DictVueStoreVo;
import digital.laboratory.platform.sys.vo.DictionaryVO;

import java.util.List;

/**
 * 字典表
 *
 * @author zhangxl
 * @date 2021-12-28
 */
public interface DictionaryService extends IService<Dictionary> {

//	/**
//	 * 通过字典类型列出字典项
//	 * @param type
//	 * @return
//	 */
//	List<Dictionary> listByType(String type);

	List<Tree<String>> treeDictionary(String parentId);


	/**
	 *
	 */
	List<Tree<String>> getTreeParentDictionary();
	/**
	 * 返回全部类型, 去重
	 * @return
	 */
	List<Dictionary> listTypes(String module);

	/**
	 * 添加字典
	 * @param dictionary
	 * @return
	 */
	Boolean addDictionary(Dictionary dictionary);

	/**
	 * 根据ID 删除字典
	 * @param id
	 * @return
	 */
	void removeDictionary(String id);

	/**
	 * 更新字典
	 * @param sysDirectory 字典
	 * @return
	 */
	void updateDictionary(Dictionary sysDirectory);

	List<DictionaryVO> listDictionaryVO(QueryWrapper<Dictionary> qw);

	/**
	 * 添加第三方字典数据
	 */
	Dictionary addThirdPartyDictionary(String label, String id);
	/**
	 * 删除数据字典
	 */
	Boolean deleteDictionary(String dictId);
	/**
	 * 获取VUE Store 加载的时候，需要一次加载的字典
	 */
	List<DictVueStoreVo>  getVueStoreLoadDictList(List<String> typeList);
}
