package digital.laboratory.platform.sys.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import digital.laboratory.platform.sys.entity.Drug;
import digital.laboratory.platform.sys.vo.SuspiciousDrugVO;

import java.util.List;
import java.util.Map;

/**
 * 毒品清单服务类
 *
 * @author Zhang Xiaolong created at  2022-06-23
 * @describe 毒品清单服务类
 */
public interface DrugService extends IService<Drug> {

    //添加毒品筛查列表
    public  Boolean addDrug(Drug drug);
    //根据根节点查出这个类下有多少个毒品
    int getDrugCountByRootId(String rootId);

    /**
     * 获取所有顶层毒品类型的数据，以map的列表返回
     * @param drugType
     * @param name
     * @param englishName
     * @param casCode
     * @return
     */
    List<SuspiciousDrugVO> drugMapList(String drugType, String name, String englishName, String casCode);

    /**
     * 分页查询
     * @param page
     * @param drug
     * @return
     */
    IPage<Drug> getDrugPage(Page page, Drug drug);
}
