package digital.laboratory.platform.sys.service;

import cn.hutool.core.lang.tree.Tree;
import com.baomidou.mybatisplus.extension.service.IService;
import digital.laboratory.platform.sys.entity.DrugType;

import java.util.List;
import java.util.Map;

/**
 * 毒品分类服务类
 *
 * @author Zhang Xiaolong created at  2022-06-23
 * @describe 毒品分类服务类
 */
public interface DrugTypeService extends IService<DrugType> {
    //获取树形结构的数据
    List<Tree<String>> getDrugTypeTreeData(String pig);
    //新增一个类型
    DrugType addDrugType(DrugType drugType);
    //根据类型ID，找出跟节点ID
    String getRootID(String drugTypeId);
    //找出这个根的所有节点
    List<String> getAllNodeByRootId(String rootId);

    /**
     * 构建毒品类型的父子关系映射
     */
    Map<String, List<String>> buildDrugTypeHierarchy(List<DrugType> allDrugTypes);
}
