package digital.laboratory.platform.sys.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import digital.laboratory.platform.sys.entity.Message;
import digital.laboratory.platform.sys.vo.MessageVO;

import java.util.List;

/**
 * 消息服务类
 *
 * @author Zhang Xiaolong created at  2023-02-02
 * @describe 消息 服务类
 */
public interface MessageService extends IService<Message> {

	Message getMessageById(String messageId, String ownerId);

	IPage<MessageVO> getMessagePage(Page<Message> page, String text, Boolean isread, String ownerId);

	List<MessageVO> getMessageList(String text, Boolean isread, String ownerId);

	boolean sendMessageToUser(String receiver, String text, String sender);

	boolean sendMessage(String orgId, boolean includeSubOrg, List<String> permissions, String text, String sender);
}
