package digital.laboratory.platform.sys.service;

import cn.hutool.core.lang.tree.Tree;
import digital.laboratory.platform.sys.entity.SysPermission;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;
import java.util.Set;

/**
 * <p>
 * 权限权限表 服务类
 * </p>
 *
 * @author lengleng
 * @since 2019/2/1
 */
public interface SysPermissionService extends IService<SysPermission> {

	/**
	 * 通过岗位 roleIds 查询URL 权限
	 * @param roleIds 岗位IDs
	 * @return 权限列表
	 */
	Set<SysPermission> findPermissionByRoleId(List<String> roleIds);

	/**
	 * 级联删除权限
	 * @param id 权限ID
	 * @return true成功, false失败
	 */
	Boolean removePermissionById(String id);

	/**
	 * 更新权限信息
	 * @param sysPermission 权限信息
	 * @return 成功、失败
	 */
	Boolean updatePermissionById(SysPermission sysPermission);

	/**
	 * 构建树
	 * @param lazy 是否是懒加载
	 * @param parentId 父节点ID
	 * @return 权限树
	 */
	List<Tree<String>> treePermission(boolean lazy, String parentId);

	/**
	 * 查询权限
	 * @param permissionSet
	 * @param parentId
	 * @return 权限树
	 */
	List<Tree<String>> filterPermission(Set<SysPermission> permissionSet, String parentId);

}
