package digital.laboratory.platform.sys.service;

import digital.laboratory.platform.sys.dto.SysRoleTypeDTO;
import digital.laboratory.platform.sys.dto.SysRoleTypeUserDTO;
import digital.laboratory.platform.sys.entity.SysUserRole;
import com.baomidou.mybatisplus.extension.service.IService;
import digital.laboratory.platform.sys.entity.SysRole;

import java.util.List;
import java.util.Set;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author lengleng
 * @since 2019/2/1
 */
public interface SysRoleService extends IService<SysRole> {

	/**
	 * 通过权限查询岗位
	 * @param permission 权限名
	 * @return
	 */
	public Set<SysUserRole> findUserRolesByPermission(String userId, String permission);

	/**
	 * 通过岗位ID, 删除岗位
	 * @param id
	 * @return
	 */
	Boolean removeRoleById(String id);

    boolean addRoleType(SysRoleTypeDTO sysRoleTypeDTO);

	boolean removeRoleType(List<SysRole> sysRoleList);

	boolean addUserRoleType(SysRoleTypeUserDTO sysRoleTypeUserDTO);

}
