package digital.laboratory.platform.sys.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import digital.laboratory.platform.sys.entity.Area;
import digital.laboratory.platform.sys.vo.AreaVO;
import digital.laboratory.platform.sys.mapper.AreaMapper;
import digital.laboratory.platform.common.core.constant.CacheConstants;
import digital.laboratory.platform.sys.service.AreaService;
import lombok.RequiredArgsConstructor;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 省/地/县 3级行政区划 服务实现类
 * </p>
 *
 * @author Zhang Xiaolong
 * @since 2022-03-10 09:45:58
 * @describe 省/地/县 3级行政区划服务实现类
 */
@Service
@RequiredArgsConstructor
public class AreaServiceImpl extends ServiceImpl<AreaMapper, Area> implements AreaService {

	@Override
	@Cacheable(value = CacheConstants.AREA_PROVINCES_DETAILS)
	public List<Area> getProvinces() {
		return this.list(Wrappers.<Area>query()
				.like("id", "__0000")
				.orderByAsc("sort"));
	}

	@Override
	public List<AreaVO> listAreaVO(QueryWrapper<Area> qw) {
		return baseMapper.listAreaVO(qw);
	}
}
